program ListTest;

uses
  Exec;

var
  List: TList;
  Node1: TNode = (
    ln_Succ: nil;
    ln_Pred: nil;
    ln_Name: 'First Node';
    ln_Type: NT_UNKNOWN;
    ln_Pri: 0;
  );
 Node2: TNode = (
    ln_Succ: nil;
    ln_Pred: nil;
    ln_Name: 'Second Node';
    ln_Type: NT_UNKNOWN;
    ln_Pri: 0;
  );
  Node3: TNode = (
    ln_Succ: nil;
    ln_Pred: nil;
    ln_Name: 'Third Node';
    ln_Type: NT_UNKNOWN;
    ln_Pri: 0;
  );

procedure PrintNode(Node: PNode);
begin
  WriteLn('  Do for Node: ', GetNodeName(Node));
end;

procedure RemoveNode(Node: PNode);
begin
  writeln('  Remove node: ', Node^.ln_Name);
  Remove(Node);
end;

var
  Node: PNode;
  i: Integer;

begin
  // Prepare the List for use
  NewList(@List);
  // Get Length of empty List
  WriteLn('ListLength = ', ListLength(@List));
  WriteLn('Add Nodes');
  // Add the first two nodes at the end of the List
  AddTail(@List, @Node1);
  AddTail(@List, @Node2);
  // Insert the Third Node after the First Node
  ExecInsert(@List, @Node3, @Node1);
  // Get Length of List
  WriteLn('ListLength = ', ListLength(@List));
  // FindNode number 2
  Node := FindName(@List, 'Second Node');
  // Check
  if Assigned(Node) then
    WriteLn('  Node Found: ', Node^.ln_Name)
  else
    WriteLn('  Node not found!');
  // GetHead
  Node := GetHead(@List);
  if Assigned(Node) then
    WriteLn('  Head Node: ', Node^.ln_Name)
  else
    WriteLn('  No Head Node!');
  WriteLn('Check all Nodes');
  ForEachNode(@List, @PrintNode);
  Writeln('Remove Node 1');
  Remove(@Node1);
  // GetTail
  Node := GetTail(@List);
  if Assigned(Node) then
    WriteLn('  Tail Node: ', Node^.ln_Name)
  else
    WriteLn('  No Tail Node!');
  writeln('Check backwards');
  for i:= ListLength(@List) - 1 downto 0 do
  begin
    writeln('  ', i + 1, '. ', Node^.ln_Name);
    Node := GetPred(Node);
  end;
  //Make List Empty
  WriteLn('Clear list');
  ForEachNodeSafe(@List,  @RemoveNode);
  Writeln('After Remove List Empty: ', IsListEmpty(@List));
end.



