program ThreadTest;

{$mode objfpc} {$H+}

uses
  arosthread, amigados, SysUtils, classes, syncobjs;

type
  TMyThread = class(TThread)
    procedure Execute; override;
  end;
var
  i: Integer;
  crit: TRTLCriticalSection;

  WriteLock:TRTLCriticalSection;

procedure OutputMsg(const Msg: string);
begin
  EnterCriticalSection(WriteLock);
  WriteLn(Msg);
  LeaveCriticalSection(WriteLock);
end;


procedure TMyThread.Execute;
begin
  i := 1;
  OutputMsg('GetThreadID Thread:' + IntToStr(GetCurrentThreadID));
  OutputMsg('####Thread OK');
  EnterCriticalSection(Crit);
  OutputMsg('####Thread done');
  LeaveCriticalSection(Crit);
  Suspend;
  OutputMsg('####After Suspend');
end;


procedure Startit;
var
  T: TMyThread;
begin
  InitCriticalSection(WriteLock);
  OutputMsg('Start');
  i := 0;
  T := TMyThread.Create(True);
  InitCriticalSection(Crit);
  EnterCriticalSection(Crit);
  OutputMsg('GetThreadID Main:' + IntToStr(GetCurrentThreadID));
  t.FreeOnTerminate := False;
  T.Start;
  sleep(1000);
  LeaveCriticalSection(Crit);
  Sleep(1000);
  OutputMsg('Resume Task');
  T.Resume;
  OutputMsg('wait for Thread');
  T.WaitFor;
  OutputMsg('thread finished');
  sleep(100);
  OutputMsg('Free Thread');
  T.Free;
  DoneCriticalSection(Crit);
  OutputMsg('end');
  DoneCriticalSection(WriteLock);
end;

begin
  StartIt;
end.
